Subject: bug#31243: closed (Re: bug#31243: 26.1; kmacro-insert-counter increments incorrectly)

From: [email-masked] (GNU bug Tracking System)
Date: Fri, 11 May 2018 09:17:02 +0000

Your bug report

#31243: 26.1; kmacro-insert-counter increments incorrectly

which was filed against the emacs package, has been closed.

The explanation is attached below, along with your original report.
If you require more details, please reply to [email-masked].

-- 
31243: http://debbugs.gnu.org/cgi/bugreport.cgi?bug=31243
GNU Bug Tracking System
Contact [email-masked] with problems

Subject: Re: bug#31243: 26.1; kmacro-insert-counter increments incorrectly
From: Eli Zaretskii <[email-masked]>
To: Allen Li <[email-masked]>
Cc: [email-masked], [email-masked]
Date: Fri, 11 May 2018 12:16:14 +0300
List-Id: <debbugs-submit.debbugs.gnu.org>

> From: Allen Li <[email-masked]>
> Date: Mon, 23 Apr 2018 00:58:00 -0700
> Cc: [email-masked],
> 	bug-gnu-emacs <bug-gnu-emacs-bounces+psainty=[email-masked]>
> 
> On Sun, Apr 22, 2018 at 9:56 PM, Phil Sainty <[email-masked]> wrote:
> > Not a bug?  I believe your expectations are incorrect.
> >
> >> C-u <f3> ;; kmacro-start-macro-or-insert-counter
> >
> >
> > This insert the *previous* macro counter.  Which is sort of "undefined" for
> > the first iteration, but zero in practice.
> 
> Ah, I see.  I guess what I'm looking for is C-u 0 <f3> (or
> alternatively C-u <f3> the second time rather than the first time).
> 
> I don't think the documentaton is very clear, because the meaning of
> "previous" is ambiguous:
> 
> With C-u, inserts previous ‘kmacro-counter’ (but do not modify counter).

Indeed, the doc string could use an improvement, and in particular,
using "previous" was misleading.  I've now clarified the doc strings,
and made a point of using "current value" in all places, instead ofg
sometimes using "previous".

One comment about what's been said by Phil:

> >> C-u <f3> ;; kmacro-start-macro-or-insert-counter
> >
> >
> > This insert the *previous* macro counter.  Which is sort of "undefined" for
> > the first iteration, but zero in practice.

Actually, the value of the counter is documented to be initialized to
zero before defining the macro, so it's non "undefined" at this stage.

Thanks, I'm closing the bug report.

Subject: 26.1; kmacro-insert-counter increments incorrectly
From: Allen Li <[email-masked]>
To: [email-masked]
Date: Sun, 22 Apr 2018 19:33:00 -0700
List-Id: <debbugs-submit.debbugs.gnu.org>

1. emacs -Q
2. Record a macro like so (starting with <f3> and ending with <f4>):

C-u <f3> ;; kmacro-start-macro-or-insert-counter
SPC ;; self-insert-command
<f3> ;; kmacro-start-macro-or-insert-counter
RET ;; newline

3. Press <f4> multiple times.

Expected:

0 0
1 1
2 2
3 3
4 4
5 5
6 6

Got:

0 0
0 1
1 2
2 3
3 4
4 5
5 6
6 7

In GNU Emacs 26.1 (build 3, x86_64-pc-linux-gnu, X toolkit, Xaw scroll bars)
 of 2018-04-20 built on cielnosurge
Repository revision: 5de608f3edb54b4f8d9774e159d0fa99484d3ac8
Windowing system distributor 'The X.Org Foundation', version 11.0.11906000
Recent messages:
For information about GNU Emacs and the GNU system, type C-h C-a.
Defining kbd macro...
New macro counter value: 1 (1)
Keyboard macro defined

Configured using:
 'configure --with-x-toolkit=lucid --with-xft --with-modules
 PKG_CONFIG_PATH=/usr/lib/imagemagick6/pkgconfig'

Configured features:
XPM JPEG TIFF GIF PNG RSVG IMAGEMAGICK SOUND GPM DBUS GSETTINGS NOTIFY
ACL GNUTLS LIBXML2 FREETYPE M17N_FLT LIBOTF XFT ZLIB TOOLKIT_SCROLL_BARS
LUCID X11 MODULES THREADS LIBSYSTEMD LCMS2

Important settings:
  value of $LANG: en_US.UTF-8
  locale-coding-system: utf-8-unix

Major mode: Lisp Interaction

Minor modes in effect:
  tooltip-mode: t
  global-eldoc-mode: t
  eldoc-mode: t
  electric-indent-mode: t
  mouse-wheel-mode: t
  tool-bar-mode: t
  menu-bar-mode: t
  file-name-shadow-mode: t
  global-font-lock-mode: t
  font-lock-mode: t
  blink-cursor-mode: t
  auto-composition-mode: t
  auto-encryption-mode: t
  auto-compression-mode: t
  line-number-mode: t
  transient-mark-mode: t

Load-path shadows:
None found.

Features:
(shadow sort mail-extr emacsbug message rmc puny seq byte-opt gv
bytecomp byte-compile cconv cl-loaddefs cl-lib dired dired-loaddefs
format-spec rfc822 mml easymenu mml-sec password-cache epa derived epg
epg-config gnus-util rmail rmail-loaddefs mm-decode mm-bodies mm-encode
mail-parse rfc2231 mailabbrev gmm-utils mailheader sendmail rfc2047
rfc2045 ietf-drums mm-util mail-prsvr mail-utils kmacro elec-pair
time-date mule-util tooltip eldoc electric uniquify ediff-hook vc-hooks
lisp-float-type mwheel term/x-win x-win term/common-win x-dnd tool-bar
dnd fontset image regexp-opt fringe tabulated-list replace newcomment
text-mode elisp-mode lisp-mode prog-mode register page menu-bar
rfn-eshadow isearch timer select scroll-bar mouse jit-lock font-lock
syntax facemenu font-core term/tty-colors frame cl-generic cham georgian
utf-8-lang misc-lang vietnamese tibetan thai tai-viet lao korean
japanese eucjp-ms cp51932 hebrew greek romanian slovak czech european
ethiopic indian cyrillic chinese composite charscript charprop
case-table epa-hook jka-cmpr-hook help simple abbrev obarray minibuffer
cl-preloaded nadvice loaddefs button faces cus-face macroexp files
text-properties overlay sha1 md5 base64 format env code-pages mule
custom widget hashtable-print-readable backquote dbusbind inotify lcms2
dynamic-setting system-font-setting font-render-setting x-toolkit x
multi-tty make-network-process emacs)

Memory information:
((conses 16 95511 7642)
 (symbols 48 20449 1)
 (miscs 40 47 143)
 (strings 32 29187 1472)
 (string-bytes 1 757235)
 (vectors 16 14106)
 (vector-slots 8 493018 7522)
 (floats 8 52 158)
 (intervals 56 248 0)
 (buffers 992 11))